
<div class="modal fade" id="accessManagerModal" tabindex="-1" aria-labelledby="accessManagerModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title fs-5" id="accessManagerModalLabel">Manage access for "{{ application.descriptive_name }}"</h1>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="user-search-bar">
          <div class="input-group">
            <input
              type="text"
              name="search-query"
              class="form-control w-50"
              placeholder="Add user by name or email"
              data-search-url="{% url 'access:search_users' %}">
            <select name="mode" class="form-select" aria-label="Select role to add">
              <option value="editor">Add as editor</option>
              <option value="viewer">Add as viewer</option>
            </select>
          </div>
          <ul class="search-results dropdown-menu"></ul>
        </div>
        <h4 class="mt-3">People with access</h4>
        <!-- Owner -->
        <form
          action="{% url 'access:update_app_access' %}"
          method="post">
          <div class="user-option d-flex flex-row px-4 py-2 align-items-center gap-3">
            <div>
              <img src="{{ application.owner.profile.get_image }}" width="40" height="40" class="rounded-circle" alt="profile image">
            </div>
            <div class="flex-grow-1">
              <div class="fw-semibold">{% if application.owner.first_name %}{{ application.owner.first_name }} {{ application.owner.last_name }}{% else %}{{ application.owner.username }}{% endif %}</div>
              <div class="text-black-50">{{ application.owner.username }}</div>
            </div>
            <div class="text-body-secondary">Owner</div>
          </div>

          <!-- Editors -->
          {% for editor in editors %}
            <div
              data-username="{{ editor.username }}"
              data-role="editor"
              class="user-option d-flex flex-row px-4 py-2 align-items-center gap-3">
              <div>
                <img src="{{ editor.profile.get_image }}" width="40" height="40" class="rounded-circle" alt="profile image">
              </div>
              <div class="flex-grow-1">
                <div class="fw-semibold full-name">
                  {% if editor.first_name %}{{ editor.first_name }} {{ editor.last_name }}{% else %}{{ editor.username }}{% endif %}
                  {% if transfer_request.receiver.username == editor.username %}
                    <span class="badge text-bg-primary">Pending owner</span>
                  {% endif %}
                </div>
                <div class="text-black-50">{{ editor.username }}</div>
              </div>
              <div class="dropdown">
                <button class="btn btn-success dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                  Editor
                </button>
                <ul class="dropdown-menu">
                  <li><a class="dropdown-item disabled text-black fw-semibold" href="#">
                    <i class="fa-solid fa-pen me-2"></i>
                    Editor
                  </a></li>
                  <li><hr class="dropdown-divider"></li>
                  <li><a class="dropdown-item remove-access-btn" href="#">Remove access</a></li>
                  <li><a class="dropdown-item demote-btn" href="#">Demote to 'Viewer'</a></li>
                  <li><a class="dropdown-item transfer-ownership-btn {% if transfer_request.receiver.username == editor.username %}disabled{% endif %}" href="#" data-bs-toggle="modal" data-bs-target="#transferOwnershipWarningModal" data-new-owner="{{ editor.username }}">Transfer ownership {% if transfer_request.receiver.username == editor.username %}(Pending approval){% endif %}</a></li>
                </ul>
              </div>
            </div>
          {% endfor %}

          <!-- Viewers -->
          {% for viewer in viewers %}
            <div
              data-username="{{ viewer.username }}"
              data-role="viewer"
              class="user-option d-flex flex-row px-4 py-2 align-items-center gap-3">
              <div>
                <img src="{{ viewer.profile.get_image }}" width="40" height="40" class="rounded-circle" alt="profile image">
              </div>
              <div class="flex-grow-1">
                <div class="fw-semibold full-name">{% if viewer.first_name %}{{ viewer.first_name }} {{ viewer.last_name }}{% else %}{{ viewer.username }}{% endif %}</div>
                <div class="text-black-50">{{ viewer.username }}</div>
              </div>
              <div class="dropdown">
                <button class="btn btn-secondary dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                  Viewer
                </button>
                <ul class="dropdown-menu">
                  <li><a class="dropdown-item disabled text-black fw-semibold" href="#">
                    <i class="fa-solid fa-eye me-2"></i>
                    Viewer
                  </a></li>
                  <li><hr class="dropdown-divider"></li>
                  <li><a class="dropdown-item remove-access-btn" href="#">Remove access</a></li>
                  <li><a class="dropdown-item promote-btn" href="#">Promote to 'Editor'</a></li>
                </ul>
              </div>
            </div>
          {% endfor %}

          <!-- Hidden inputs -->
          {% csrf_token %}
          <input type="hidden" name="app_id" value="{{ application.identifier }}">
          <input type="hidden" name="editors" value="{{ editor_usernames|join:',' }}">
          <input type="hidden" name="viewers" value="{{ viewer_usernames|join:',' }}">
        </form>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" class="btn btn-primary submit-btn">Save changes</button>
      </div>
    </div>
  </div>
</div>
